# Project Creator

This is a simple CLI app to create a startup structure Github or Gitea project.

## Description

The **KodeStarter** app allows you to:

- Create a Github project (repo)
- Initialize a Git repository
- Create an initial commit
- Generate a README.md file

It uses the Github API to create projects.

## Usage

To build and run the app:

```bash
go build
./kode-starter.exe 
```

This will show the help menu. The main commands are:

- `create` - Create a Github project
- `list` - List Github orgs and repos

To create a project:

```bash
./kode-starter.exe create -t <github_token> -o <org_name> -n <project_name> -d <description> -p <private|false>
```

For example:

```bash 
./kode-starter.exe create -t abc123 -o myorg -n myproject -d "A test project" -p false
```

This will:

- Create a public Github repo named `myproject` in the `myorg` org
- Create a directory named `myproject`
- Initialize a Git repo
- Make an initial commit
- Generate a README.md

To list Github orgs and repos:

```bash
./kode-starter.exe list -t <github_token> -o <org_name>  
```

For example:

```bash
./kode-starter.exe list -t abc123 -o myorg
```

This will list the repos in the `myorg` organization.

## Environment Variables

You can set the following environment variables:

- `GIT_TOKEN` - Your Github personal access token. This will be used instead of passing the `-t` flag.

##License

MIT License.