package structures

// The "Project" type represents a project with a name, privacy status, and description.
// @property {string} Name - Name is a property of a struct type called Project. It is a string type
// field that represents the name of the project. The `json:"name"` tag is used to specify the name of
// the field when encoding or decoding JSON data.
// @property {bool} Private - Private is a boolean property that indicates whether the project is
// private or not. If it is set to true, only authorized users can access the project. If it is set to
// false, the project is public and can be accessed by anyone.
// @property {string} Description - The "Description" property is a string that represents the
// description of a project. It provides additional information about the project, such as its purpose,
// features, or functionality. This property is used in the "Project" struct, which is a data structure
// used to represent a project in a programming language.
type Project struct {
	Name        string `json:"name"`
	Private     bool   `json:"private"`
	Description string `json:"description"`
}
